#include <cmath>
#include <iomanip>
#include <iostream>
using namespace std;
const double prec=1.e-12,fprec=1.e-12;
const int nprec=10, nwidth=16;
const int numiter=100;
const char* tab="\t";
inline double f(double x){return atan(x);}
inline double fd(double x){return 1./(1+x*x);}
int biseccion (double,double,double &);
int newton (double,double,double &);
int main()
{
double x0,x1;
cout <<"Elije el intervalo en el cual comprobaremos la existencia"<<"\n";
cout <<"de un cero de la funcion a estudiar,x0 y x1."<<endl;
cout <<"Introduce el valor del limite inferior x0,x0="<<"\n";
cin >> x0;
cout <<"Introduce el valor del limite superior x1,x1="<<"\n";
cin >> x1;
double &raiz=x1;
int estado;
estado=newton(x0,x1,raiz);
if (estado=0)
cout <<"raiz= "<<raiz<<endl;
else
{
biseccion(x0,x1,raiz);
cout <<endl<<"en main()"<<" raiz= "<<raiz<<endl;
}
return 0;
}
int biseccion (double x0,double x1,double &raiz)
{
int n=0;
double x2,f0,f1,f2;
f0=f(x0);
f1=f(x1);
if (f0*f1>0)
{
cout <<"no hay raiz entre x0 y x1"<<endl;
return 1;
}
while ( abs(x0-x1)>=prec )
{
if (n>=numiter)
{
cout <<"numero maximo de iteraciones excedido en biseccion"<<endl;
return 1;
}
x2=(x0+x1)/2;
f2=f(x2);
if (f2*f0<0)
{
x1=x2;
f1=f2;
}
if (f2*f1<0)
{
x0=x2;
f0=f2;
}
n++;
}
raiz=x2;
cout <<"biseccion "<<n<<" iteraciones"<<" raiz= "<<setprecision(nprec)<<setw(nwidth)<<raiz<<" funcion= "<<f(raiz)<<endl;
return 0;
}
int newton (double a,double b,double &raiz)
{
int n=0;
double x1=a,x2=b;
double f1=f(x1),eps=1.;
while (abs (f1)>=fprec||eps>=prec)
{
x2=x1-f1/fd(x1);
eps=abs(x2-x1);
if (x2<=a||x2>=b)
{
cout <<"newton fuera de control"<<endl<<endl;/*Esto es un error!*/
return 1;
}
x1=x2;
f1=f(x1);
n++;
}
raiz=x2;
cout <<"newton "<<n<<" iteraciones "<<" raiz= "<<raiz<<" funcion= "<<f(raiz)<<endl;
return 0;
}









