/* -*- mode: c++ -*- */


#ifndef __RAICES__
#define __RAICES__

#include <matutil.h>  // typedef de func


/**
 *\defgroup raices Documentacin de la Prctica 3 
 */

/// Inicializa el algoritmo de biseccin
int bisecIni(func f, double a, double b);

/// Ejecuta una iteracin del algoritmo de biseccin
int bisecIter(func f, double& a, double& b, double& raiz);

/// Inicializa el algoritmo de regula falsi
int rfalsiIni (func f, double a, double b);

/// Ejecuta una iteracin del algoritmo de regula falsi
int rfalsiIter(func f, double& a, double& b, double& raiz);

/// Inicializa el algoritmo de newton-rapson 
int newtonIni(func F, func dF, double& f_raiz, double& df_raiz, double& raiz);

/// Ejecuta una iteracin del algoritmo de newton-rapson 
int newtonIter(func F, func dF, double& f_raiz, double& df_raiz, double& raiz);

#endif






